/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import javax.swing.JFrame;

public class Domino{

private Giocatore[] g;
private int cartaP;
private Tavolo tav;
private Graph p;
private Game game;

public Domino(){

tav=new Tavolo();

}

protected void init(int n,JFrame f,Graph p){

this.p=p;

tav.reset();    
    
g=new Giocatore[n];

if (n==3) cartaP=(int)(Math.random()*3);   

game=new Game(f,p,this);

}

protected void reset(){

tav.reset();    
if (game!=null) game.termina();
game=null;   
g=null;


}

protected Game getGame(){
return game;
}

public boolean esisteC(int c){
return tav.esisteC(c);
}

public boolean esisteC(int s,int v){
return tav.esisteC(s,v);
}

public boolean isValidAdd(int c){
return tav.isValidAdd(c);
}


protected void gioca(int id){

if (id==0) return;

for(int i=id;i<g.length;i++){
    while(p.isAnim()); 
    Carta c=getG(i).getCarta();
    if (c!=null){ p.setAnim(i,getG(i).getID());
                  tav.add(c);
        
    if (getG(i).isEnd() && getG(i).getPosizione()==-1)
        getG(i).setPosizione(game.getPos());
    }       


    p.repaint();

      }
}

protected void gioca(){

gioca(getStartID());    

}

protected void gioca(Carta c){
while(p.isAnim()); 
if (c!=null){ p.setAnim(0,getG(0).getID());
              tav.add(c);
              
    if (getG(0).isEnd() && getG(0).getPosizione()==-1)
        getG(0).setPosizione(game.getPos());           
             
    }

p.repaint();
gioca(1);
    
}

protected boolean isActive(){

if (g==null) return false;

return true;
}



protected void addG(Giocatore p){

for(int i=0;i<g.length;i++)
     if(g[i]==null){
                   g[i]=p;
                   break;
		   }

}

protected int numeroG(){

return g.length;
}

protected Giocatore getG(int p){

if (p<g.length) return g[p];

return null;
}

protected void assegnaCarte(){

if (g.length==3 && ++cartaP==3) cartaP=0;

Giocatore lista=new RandomPlayer("",this);
Giocatore mazzo=new RandomPlayer("",this);

for (int i=0;i<40;i++) 
lista.addC(new Carta(i+1));

while(lista.sizeMano()>0){

mazzo.addC(lista.getCarta());
}

while(mazzo.sizeMano()>0){

if (mazzo.sizeMano()/3<g.length){
for (int i=0;i<g.length;i++){
if (g.length==5) 
       g[i].addC(mazzo.remC(0));
       g[i].addC(mazzo.remC(0));  
}
if (g.length==3) g[cartaP].addC(mazzo.remC(0));
}
else
for (int i=0;i<g.length;i++){
      g[i].addC(mazzo.remC(0));
      g[i].addC(mazzo.remC(0));   
      g[i].addC(mazzo.remC(0));       
      }
      
}

}

protected int getStartID(){

int startID=-1;

    if(g.length==3) startID=cartaP;
    else {
    for (int i=0;i<g.length;i++)
    for (int j=0;j<g[i].sizeMano();j++)       
      if(g[i].readC(j).carta==Carta.Q5) {startID=i; break;}
               
    }

return startID;
}


}