/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class DominoMenu{
	
	protected Graph p;
	protected JFrame f;	
	protected JCheckBoxMenuItem mPass,mAnim,mTyp;
		
	public DominoMenu(JFrame f,Graph p){
		
		this.f=f;
		this.p=p;

		}
	
	
	public JMenuBar setMenu(Domino d){
		
		
		
    JMenuBar menuBar=new JMenuBar();
    JMenu mDom=new JMenu("Domino");
    JMenuItem mS=new JMenuItem("Start");
    JMenu mOpz=new JMenu("Opzioni");
    mPass=new JCheckBoxMenuItem("Passa automaticamente");
    mAnim=new JCheckBoxMenuItem("Movimento carte"); 
    mTyp=new JCheckBoxMenuItem("Usa carte italiane"); 
    JMenu mHelp=new JMenu("Help");
    JMenuItem mAbt2=new JMenuItem("Info Player");
    JMenuItem mAbt=new JMenuItem("About");

    mPass.setState(false);
    mAnim.setState(true);
    p.setMov(true);
    p.setAutoPassState(false);
    p.setIT(false);
    
  menuBar.add(mDom);
  menuBar.add(mOpz);  
    menuBar.add(mHelp);   
	mDom.add(mS);
        mOpz.add(mPass);
        mOpz.add(mAnim);   
        mOpz.add(mTyp); 
        mHelp.add(mAbt2);
	mHelp.add(mAbt);
	menuListener l=new menuListener(d);

	mS.addActionListener(l);
        mPass.addActionListener(l);
        mAnim.addActionListener(l);
	mAbt2.addActionListener(l);        
	mAbt.addActionListener(l);
	mTyp.addActionListener(l);
    
	return menuBar;
		}
	
	
class menuListener implements ActionListener{

    private Domino d;
    
    public menuListener(Domino d){
    this.d=d;
    
    }
    
	public void actionPerformed(ActionEvent e){
		  
        if(e.getActionCommand().equalsIgnoreCase("Start")){
            
(new SelCP(f,true,p,d)).setVisible(true);

       }
        
        
        if(e.getActionCommand().equalsIgnoreCase("Usa carte italiane")){
        
        if (mTyp.getState()){
        p.setIT(true);           
        }else{
        p.setIT(false);        
        }
        p.repaint();
        }
        
        if(e.getActionCommand().equalsIgnoreCase("Passa automaticamente")){
        
        if (mPass.getState()){
        p.setAutoPassState(true);           
        }else{
        p.setAutoPassState(false);        
        }
        
        }

        if(e.getActionCommand().equalsIgnoreCase("Movimento carte")){
        
        if (mAnim.getState()){
        p.setMov(true);           
        }else{
        p.setMov(false);        
        }
        
        }
        
    	if(e.getActionCommand().equalsIgnoreCase("about"))
        {  JDialog d=new JDialog(f,"About Domino",true);
  
           About a=new About(d);
           d.setResizable(false);
     
	       d.setContentPane(a);

	       d.pack();
	   
	   Graph.centraWindow(d);
	   
	       d.setVisible(true);
               	}
        
     	if(e.getActionCommand().equalsIgnoreCase("Info Player"))
        {             
            JDialog d= new AboutDialog(f);
               
	   Graph.centraWindow(d);
	   
	       d.setVisible(true);
               	}       


	}

	}
	
private class About extends JPanel{
	
	private JDialog d;
	
      
   public About(JDialog d) {
   	this.d=d;

   	setLayout(new GridLayout(2,1));
JPanel panel=new JPanel();

panel.setLayout(new GridLayout(4,1));

JPanel p1=new JPanel();
JPanel p2=new JPanel();

  	JLabel l1=new JLabel("www.xDestroyer.altervista.org",JLabel.CENTER);
   	JLabel l2=new JLabel("Destroyer@email.it",JLabel.CENTER);

   add(new JLabel(new ImageIcon(this.getClass().getResource("logo.jpg")),JLabel.CENTER));


   l1.setForeground(Color.RED);
   l2.setForeground(Color.RED);
   setBackground(Color.black); 
   p1.setBackground(Color.black); 
   p2.setBackground(Color.black);  
   panel.add(l1);
   panel.add(l2);   

      
   JButton ok= new JButton("ok");
   JButton gpl= new JButton("Released under the GNU General Public License");
AboutListener Al=new AboutListener();
ok.addActionListener(Al);
gpl.addActionListener(Al);
ok.setForeground(Color.RED);
gpl.setForeground(Color.RED);
ok.setBackground(Color.BLACK);
gpl.setBackground(Color.BLACK);


p1.add(gpl,JLabel.CENTER);
p2.add(ok,JLabel.CENTER);

panel.add(p1);
panel.add(p2);
panel.setBackground(Color.BLACK);
add(panel);
     }
private class AboutListener implements ActionListener{


	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand().equalsIgnoreCase("ok")){
			
		   d.setVisible(false);
			}
		
		if(e.getActionCommand().equalsIgnoreCase("Released under the GNU General Public License")){
			
		  JDialog gpl=new JDialog(d,"GNU General Public License",true);
		  JTextArea text=new JTextArea(30,40);

          JScrollPane scroll=new JScrollPane(text);
          text.setEditable(false);

         leggiGPL(text);
         
text.setCaretPosition(0);
text.setTabSize(4);



		  gpl.setContentPane(scroll);
     
          gpl.setResizable(false);
	       gpl.pack();
	       Graph.centraWindow(gpl);

	       gpl.setVisible(true);	
	       
	}
					
           	
           	}
           	
           	private void leggiGPL(JTextArea t){
           		try{
           		BufferedReader gpl=new BufferedReader(new InputStreamReader(this.getClass().getResourceAsStream("gpl.txt")));
           		
           		String line;
           		while ((line=gpl.readLine())!=null)
           		t.append(" "+line+"\n");
           		          		
           		gpl.close();	
           		}catch(IOException e){}
           		}
		}
	}	

	
	
	}