/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import java.util.*; 

public abstract class Giocatore{
    
public final String nome;
private Vector<Carta> mano; 
private int posizione;
private Domino d; 
protected int id;

public static String about(){

return null;
}

public Giocatore(String nome,Domino d){

this.nome=nome;
this.d=d;

initMano();

id=-1;
posizione=-1;
}

public boolean esisteC(int c){
return d.esisteC(c);
}

public boolean esisteC(int s,int v){
return d.esisteC(s,v);
}

public boolean isValidAdd(int c){
return d.isValidAdd(c);
}

private final void initMano(){

mano=new Vector<Carta>(0,1);

}

public final void addC(Carta c){

mano.add(c);

}

public final Carta remC(int p){

Carta r=mano.remove(p);
mano.trimToSize();
return r;

}

public final Carta readC(int p){

return mano.elementAt(p);

}

public final int sizeMano(){

return mano.size();

}

public final int nValid(){

int n=0;
for(int i=0;i<mano.size();i++) if (d.isValidAdd(readC(i).carta)) n++;

return n;
}

public final void ordinaMano(){

for(int i=1;i<mano.size();i++){
           for(int j=0;j<i;j++)
	           if (mano.elementAt(i).carta<mano.elementAt(j).carta)
                                        mano.insertElementAt(remC(i),j);
	    }

}

public abstract Carta getCarta();

public final int getID(){

    if (id>=0 && id<=mano.size())   
    return id;   
    
    else return ((int)(Math.random()*(mano.size()+1)));
}

public final boolean isEnd(){

if (mano.size()==0) return true;

return false;

}

public final void setPosizione(int p){
posizione=p;
}

public final int getPosizione(){
return posizione;
}

}
