/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;


import java.awt.image.renderable.RenderableImage;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.image.ImageObserver;
import java.awt.event.*;
import javax.swing.event.PopupMenuListener;

public class Graph extends JPanel {
    
public static final int WW=1000;
public static final int WH=750; 

public static void centraWindow(Window w){

int x,y;
		
x=(Toolkit.getDefaultToolkit().getScreenSize().width-w.getWidth())/2;
y=(Toolkit.getDefaultToolkit().getScreenSize().height-w.getHeight())/2;
	
w.setLocation(x,y);
		
}

    private int move,vuoto,pl;
    private int sW,sH,cW,cH,scX,scY,brdW,brdH,ctW,mx,my;
    private Domino d; 
    private PngImage png;
    private boolean autoPass,mov;
    protected JPopupMenu popup;
    protected JButton jButton;
    
    public Graph(Domino d) {
    this.d=d;
    this.setPreferredSize(new Dimension(WW,WH));
    png=new PngImage(false,this);
    this.addMouseListener(new MouseClick());
    this.addMouseMotionListener(new MouseMove());
    setBackground(Color.DARK_GRAY);
    setForeground(Color.BLUE);    
    
    popup=new JPopupMenu();
    
    popup.add("ordina").addActionListener(new PopList());
        
    setFont(new Font("",Font.BOLD,getFont().getSize()));
    
        setLayout(new java.awt.BorderLayout());
        jButton= new JButton();
        jButton.setText("Passa");
        add(jButton, java.awt.BorderLayout.SOUTH); 
        jButton.setVisible(false);
        
         jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            passa();
            }
        });
    }

    private void passa(){
        
        jButton.setVisible(false);   
        
        ((LocalPlayer) d.getG(0)).selectC(-1); 
       
           synchronized(d.getGame()) {
           d.getGame().sveglia();
           d.getGame().notify();
           }
        
    
    }
    
    protected void paintComponent(Graphics g) {

        super.paintComponent(g);
        Graphics2D g2=(Graphics2D) g;
   
    if (d.isActive()) drawPanel(g2);
    }
    
    private void drawPanel(Graphics2D g2){
 
        
        ctW=cW=png.getWidth();
        cH=png.getHeight();
        sW=this.getWidth();
        sH=this.getHeight();
        scX=sW/2;
        scY=sH/2;
        brdW=sW*2/100;
        brdH=sH*2/100;

                
        int smin=Math.min(sW,sH);
        int bmin=Math.min(brdW,brdH);
        int cmax=0;
        
    int n=d.numeroG();
    int shift=0;
        

        
    if (n==5){
        shift=sW/4;
        smin=Math.min(sW*2/3,sH);
    }   
        
    
        if (n==3) cmax=14;
        else if (n==4) cmax=10;
        else if (n==5) cmax=8;

    
        if (smin<(cW*cmax+2*bmin+ctW+shift+cH))
            cW=(smin-(2*bmin+ctW+shift+cH))/cmax;
        
          
        for (int i=1;i<=40;i++)
            if (d.esisteC(i))
            drawImageTav(g2,i);
    
     
    
    if (n==3){
    if (isAnim() && pl==0) drawImageGAnim(g2, 0, 0, false);
    else    
     drawImageG(g2, 0, 0, false);
    if (isAnim() && pl==1) drawImageGAnim(g2, 1, 0, true);
    else 
     drawImageG(g2, 1, 0, true);
    if (isAnim() && pl==2) drawImageGAnim(g2, 2, 0, true);
    else 
     drawImageG(g2, 2, 0, true);     
    }
    else
    if (n==4){
    if (isAnim() && pl==0) drawImageGAnim(g2, 0, 0, false);
    else    
     drawImageG(g2, 0, 0, false);
    if (isAnim() && pl==1) drawImageGAnim(g2, 1, 0, true);
    else 
     drawImageG(g2, 1, 0, true);
    if (isAnim() && pl==2) drawImageGAnim(g2, 2, 0, false);
    else 
     drawImageG(g2, 2, 0, false);     
    if (isAnim() && pl==3) drawImageGAnim(g2, 3, 0, true);
    else 
     drawImageG(g2, 3, 0, true);    
    }    
    else
    if (n==5){
    if (isAnim() && pl==0) drawImageGAnim(g2, 0, 0, false);
    else    
     drawImageG(g2, 0, 0, false);
    if (isAnim() && pl==1) drawImageGAnim(g2, 1, 0, true);
    else 
     drawImageG(g2, 1, 0, true);
    if (isAnim() && pl==2) drawImageGAnim(g2, 2, -shift, false);
    else 
     drawImageG(g2, 2, -shift, false);  
    if (isAnim() && pl==3) drawImageGAnim(g2, 3, +shift, false);
    else 
     drawImageG(g2, 3, +shift, false);    
    if (isAnim() && pl==4) drawImageGAnim(g2, 4, 0, true);
    else 
     drawImageG(g2, 4, 0, true);    
    }   

   
    }
    
   private void drawImageG(Graphics2D g2,int gn,int shift,boolean ang){
    
    int x,y;
    
    if(ang){
    x=(sH-(d.getG(gn).sizeMano()*cW+2*brdH))/2+shift;
    if (gn==1) y=brdW;
    else       y=sW-cH-brdW;    
    }else{
    x=(sW-(d.getG(gn).sizeMano()*cW+2*brdW))/2+shift;
    if (gn==0) y=sH-cH-brdH;
    else       y=brdH;
    }
    
    if (ang) g2.drawString(d.getG(gn).nome,y,x);
    else if (gn!=0) g2.drawString(d.getG(gn).nome,x,y);
    
      
    for(int i=0;i<d.getG(gn).sizeMano();i++,x+=cW)
        if (gn==0) g2.drawImage(png.getImage(d.getG(gn).readC(i).carta),x,y,this);
        else if (!ang) g2.drawImage(png.getCop(),x,y,this);
        else drawImage90(g2,png.getCop(), y, x);
   
    }
    
    private void drawImageGAnim(Graphics2D g2,int gn,int shift,boolean ang){
    
    
    int x,y;
    if(ang){
    x=(sH-(d.getG(gn).sizeMano()*cW+2*brdH+move))/2+shift;
    if (gn==1) y=brdW;
    else       y=sW-cH-brdW;    
    }else{
    x=(sW-(d.getG(gn).sizeMano()*cW+2*brdW+move))/2+shift;
    if (gn==0) y=sH-cH-brdH;
    else       y=brdH;
    }
    
    if (ang) g2.drawString(d.getG(gn).nome,y,x);
    else if (gn!=0) g2.drawString(d.getG(gn).nome,x,y);   
    
    for(int i=0;i<d.getG(gn).sizeMano()+1;i++,x+=cW){
        int c=i;
        
        if (vuoto<i) c=i-1;   
        
        if (vuoto==i) x=x-cW+move;
        else{
        if (gn==0) g2.drawImage(png.getImage(d.getG(gn).readC(c).carta),x,y,this);
        else if (!ang) g2.drawImage(png.getCop(),x,y,this);
        else drawImage90(g2,png.getCop(), y, x);
    }}
    
    try{
    Thread.sleep(50);
    }catch(Exception e){}
    moveAnim();
    repaint();
    
    }
    
    public boolean isAnim(){
    
    if (move>0) return true;
    move=0;
    return false;
    }
    
    public void setAnim(int g,int pos){
    
    if (mov){        
    vuoto=pos;    
    move=cW;
    pl=g;
    }
    else if (g!=0) try{
    Thread.sleep(500);
    }catch(Exception e){}
    }
    
    private void moveAnim(){
    move=move-cW/10;
    }
    
    public void setMov(boolean m){
    mov=m;
    }
    
    public boolean isMov(){
    
    return mov;
    }
    
    public void setIT(boolean b){
    png.cambiaTipo(b);
    }
    
    private boolean drawImageTav(Graphics2D g2,int c){
   
    int x,y;    
    int s=Carta.getSeme(c);    
    int v=Carta.getValore(c);
    
     if (v>5) x=(v-6)*ctW+scX;
     else x=scX-(6-v)*ctW;
     if (s>2) y=(s-3)*cH+scY;
     else y=scY-(3-s)*cH;
    
    return g2.drawImage(png.getImage(c),x,y,this);
    }
            
    private boolean drawImage90(Graphics2D g2,Image img,int x,int y){
    
        x=x+(img.getHeight(this)-img.getWidth(this))/2;
        y=y-(img.getHeight(this)-img.getWidth(this))/2;   
        
    return drawToG2(g2,img,x,y,90);
    }
    
    private boolean drawToG2(Graphics2D g2,Image img,int x,int y,int ang){
    
    AffineTransform at=new AffineTransform();     
  
       at.setToTranslation(x,y);
       at.rotate(Math.toRadians(ang),img.getWidth(this)/2.0,img.getHeight(this)/2.0);
       
        
    return g2.drawImage(img,at,this);
    }
 
    public boolean getAutoPassState(){
    return autoPass;
    }
    
    public void setAutoPassState(boolean s){
    autoPass=s;
    }
   
 class MouseClick extends MouseAdapter {
     
          
  public void mouseClicked(MouseEvent e){
 
       int x=e.getX();
       int y=e.getY();
      
      if (!d.isActive() || !d.getGame().isReady() || isAnim() || d.getG(0).isEnd()) return;
       
      if (e.getButton()!=MouseEvent.BUTTON1) return;
      
      if (!autoPass && d.getG(0).nValid()==0) return;
    
      
       int r,l,t,b;
       
       t=sH-cH-brdH;
       b=sH-brdH;
       l=(sW-(d.getG(0).sizeMano()*cW+2*brdW))/2;
       r=l+d.getG(0).sizeMano()*cW-cW+ctW;
       
         
    if (y>t && y<b && x>l && x<r){
   
   int i=(x-l)/cW;
   if (i>=d.getG(0).sizeMano()) i=d.getG(0).sizeMano()-1;
   
   if (d.isValidAdd(d.getG(0).readC(i).carta)){
   ((LocalPlayer) d.getG(0)).selectC(i);
   
    synchronized(d.getGame()) {
           d.getGame().sveglia();
           d.getGame().notify();
           }
   }
   }
  }
       
     
     public void mousePressed(MouseEvent e) { 
       if (!d.isActive() || !d.getGame().isReady() || isAnim() || d.getG(0).isEnd()) return;  
       if (e.isPopupTrigger()) { 
          popup.show(e.getComponent(),e.getX(), e.getY()); 
       } 
     } 
     public void mouseReleased(MouseEvent e) { 
       if (!d.isActive() || !d.getGame().isReady() || isAnim() || d.getG(0).isEnd()) return; 
       if (e.isPopupTrigger()) { 
         popup.show(e.getComponent(),e.getX(), e.getY()); 
       } 
     }     
       
       
     
    
}
 
class MouseMove extends MouseMotionAdapter{

public void mouseMoved(MouseEvent e){

    mx=e.getX();
    my=e.getY();
if (d.isActive() && d.getGame().isReady() && !autoPass && !d.getG(0).isEnd() && d.getG(0).nValid()==0) repaint();
}

}

class PopList implements ActionListener{

    	public void actionPerformed(ActionEvent e){
		  
        if(e.getActionCommand().equalsIgnoreCase("ordina")){
            
         d.getG(0).ordinaMano();
         
         repaint();
        }
        }

}
 
}



