/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;
import java.awt.*;

public class PngImage {

    private boolean it;
    private Graph p;
    private Image[] carta;
    private Image cop;
    
    public PngImage(boolean it,Graph p) {
    
    this.p=p;
    this.it=it;
    carta=new Image[40];
    loadCarte();
    
    }

    private void loadCarte(){
         
        for (int i=0;i<carta.length;i++)  
            carta[i]=loadImage(i+1);
        
        MediaTracker tracker = new MediaTracker(p);

        for (int i=0;i<carta.length;i++)   
        tracker.addImage(carta[i], 0);	

        cop=loadCop();
        tracker.addImage(cop, 0);
        
        try{	    
	    tracker.waitForID(0);
	}catch(Exception e){}      

    }
    
    private Image loadImage(int n){
    
    int s=Carta.getSeme(n);  
    int v=Carta.getValore(n);
    
    String S="",V="",I="";
    
    if (s==Carta.C) S="c";
    if (s==Carta.Q) S="d"; 
    if (s==Carta.F) S="f"; 
    if (s==Carta.P) S="p";
    
    V=""+v;
    
    if (it) I="i";
    
    return Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("png/"+S+V+I+".png"));
    }
    
    private Image loadCop(){
    
    String I="";
    
    if (it) I="i";   
     
    return Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("png/"+"cop"+I+".png"));    
    }
    
    public Image getCop(){
    
    return cop;
    }    
    
    public Image getImage(int c){
    
    return carta[c-1];
    }

    public int getWidth(){
    
       return carta[0].getWidth(p);
        
    }

    public int getHeight(){
    
       return carta[0].getHeight(p);
        
    }    
    
    public void cambiaTipo(boolean it){
    
    this.it=it;
    loadCarte();
   
    }
    
}
